Imports System.Xml
Imports System.Xml.Schema
Imports System.Xml.Serialization

Public Class ConvertUnit
    Implements IXmlSerializable

#Region "ϐ`"
    Private mBaseRate As Decimal
    Private mBaseUnitName As String
    Private mResultRate As Decimal
    Private mResultUnitName As String
    Private mIsAvailable As Boolean
    Private mIsSwap As Boolean
    Private mSelected As Boolean
#End Region

#Region "RXgN^"
    Public Sub New()
        Me.mBaseRate = 1
        Me.mBaseUnitName = ""
        Me.mResultRate = 1
        Me.mResultUnitName = ""
        Me.mIsAvailable = True
        Me.mIsSwap = False
        Me.mSelected = False
    End Sub
#End Region

#Region "vpeB"
    Public ReadOnly Property Description() As String
        Get
            Return String.Format("{0}{1}{2}{3}", _
                    Me.mBaseRate, Me.mBaseUnitName, _
                    Me.mResultRate, Me.mResultUnitName)
        End Get
    End Property

    Public ReadOnly Property SwapBaseRate() As Decimal
        Get
            If Me.IsSwap Then
                Return Me.ResultRate
            Else
                Return Me.BaseRate
            End If
        End Get
    End Property

    Public Property BaseRate() As Decimal
        Get
            Return Me.mBaseRate
        End Get
        Set(ByVal value As Decimal)
            Me.mBaseRate = value
        End Set
    End Property

    Public ReadOnly Property SwapBaseUnitName() As String
        Get
            If Me.IsSwap Then
                Return Me.ResultUnitName
            Else
                Return Me.BaseUnitName
            End If
        End Get
    End Property

    Public Property BaseUnitName() As String
        Get
            Return Me.mBaseUnitName
        End Get
        Set(ByVal value As String)
            Me.mBaseUnitName = value
        End Set
    End Property

    Public ReadOnly Property SwapResultRate() As Decimal
        Get
            If Me.IsSwap Then
                Return Me.BaseRate
            Else
                Return Me.ResultRate
            End If
        End Get
    End Property

    Public Property ResultRate() As Decimal
        Get
            Return Me.mResultRate
        End Get
        Set(ByVal value As Decimal)
            Me.mResultRate = value
        End Set
    End Property

    Public ReadOnly Property SwapResultUnitName() As String
        Get
            If Me.IsSwap Then
                Return Me.mBaseUnitName
            Else
                Return Me.mResultUnitName
            End If
        End Get
    End Property

    Public Property ResultUnitName() As String
        Get
            Return Me.mResultUnitName
        End Get
        Set(ByVal value As String)
            Me.mResultUnitName = value
        End Set
    End Property

    Public Property IsAvailable() As Boolean
        Get
            Return Me.mIsAvailable
        End Get
        Set(ByVal value As Boolean)
            Me.mIsAvailable = value
        End Set
    End Property

    Public Property IsSwap() As Boolean
        Get
            Return Me.mIsSwap
        End Get
        Set(ByVal value As Boolean)
            Me.mIsSwap = value
        End Set
    End Property

    Public Property Selected() As Boolean
        Get
            Return Me.mSelected
        End Get
        Set(ByVal value As Boolean)
            Me.mSelected = value
        End Set
    End Property
#End Region

#Region "\bh"
    Public Function Convert(ByVal value As Decimal) As Decimal
        'ϊs
        Dim result As Decimal = value * Me.SwapResultRate / Me.SwapBaseRate
        result = Math.Round(result, 2)
        Return result
    End Function
#End Region

#Region "IXmlSerializable̎"
    Public Function GetSchema() As XmlSchema Implements IXmlSerializable.GetSchema
        Return Nothing
    End Function

    Public Sub ReadXml(ByVal reader As XmlReader) Implements IXmlSerializable.ReadXml
        reader.ReadStartElement()
        Do While reader.IsStartElement
            Select Case reader.LocalName
                Case "BaseRate"
                    Me.mBaseRate = reader.ReadElementContentAsDecimal()
                Case "BaseUnitName"
                    Me.mBaseUnitName = reader.ReadElementContentAsString()
                Case "ResultRate"
                    Me.mResultRate = reader.ReadElementContentAsDecimal()
                Case "ResultUnitName"
                    Me.mResultUnitName = reader.ReadElementContentAsString()
                Case "IsAvailable"
                    Me.mIsAvailable = Boolean.Parse(reader.ReadElementContentAsString())
                Case "IsSwap"
                    Me.mIsSwap = Boolean.Parse(reader.ReadElementContentAsString())
                Case "Selected"
                    Me.mSelected = Boolean.Parse(reader.ReadElementContentAsString())
                Case Else
                    'mȂꍇAǂ
                    reader.ReadContentAsString()
            End Select
        Loop
        reader.ReadEndElement()
    End Sub

    Public Sub WriteXml(ByVal writer As XmlWriter) Implements IXmlSerializable.WriteXml
        writer.WriteStartElement("ConvertUnit")
        writer.WriteElementString("BaseRate", Me.mBaseRate.ToString())
        writer.WriteElementString("BaseUnitName", Me.mBaseUnitName)
        writer.WriteElementString("ResultRate", Me.mResultRate.ToString())
        writer.WriteElementString("ResultUnitName", Me.mResultUnitName)
        writer.WriteElementString("IsAvailable", Me.mIsAvailable.ToString())
        writer.WriteElementString("IsSwap", Me.mIsSwap.ToString())
        writer.WriteElementString("Selected", Me.mSelected.ToString())
        writer.WriteEndElement()
    End Sub
#End Region

End Class
