Imports System.IO
Imports System.Xml
Imports System.Xml.Schema
Imports System.Xml.Serialization

Public Class ConvertUnitList
    Implements IXmlSerializable

#Region "ϐ`"
    Private mItems As IList(Of ConvertUnit)

    Private mFileName As String
#End Region

#Region "RXgN^"
    Private Sub New()
        'RXgN^͎gȂ
        Me.mItems = New List(Of ConvertUnit)
    End Sub
#End Region

#Region "vpeB"
    Public ReadOnly Property Items() As IList(Of ConvertUnit)
        Get
            Return Me.mItems
        End Get
    End Property

    Public ReadOnly Property SelectedUnit() As ConvertUnit
        Get
            For Each cu As ConvertUnit In Me.mItems
                If cu.Selected Then
                    Return cu
                End If
            Next
            Return Nothing
        End Get
    End Property
#End Region

#Region "\bh"
    Public Sub Add(ByVal baseRate As Decimal, _
                   ByVal baseUnitName As String, _
                   ByVal resultRate As Decimal, _
                   ByVal resultUnitName As String)
        Dim cu As ConvertUnit = New ConvertUnit()
        cu.BaseRate = baseRate
        cu.BaseUnitName = baseUnitName
        cu.ResultRate = resultRate
        cu.ResultUnitName = resultUnitName
        Me.mItems.Add(cu)
    End Sub

    Public Function SetSelect(ByVal description As String) As ConvertUnit
        For Each cu As ConvertUnit In Me.mItems
            cu.Selected = (cu.Description = description)
        Next
        Return Me.SelectedUnit
    End Function
#End Region

#Region "f[^̓Ǎ/ۑ"
    Public Shared Function Load(ByVal fileName As String) As ConvertUnitList
        Dim result As ConvertUnitList
        Try
            Dim serializer As XmlSerializer = New XmlSerializer(GetType(ConvertUnitList))
            Using stream As StreamReader = New StreamReader(fileName)
                result = CType(serializer.Deserialize(stream), ConvertUnitList)
                stream.Close()
            End Using
        Catch ex As Exception
            'ftHg̍쐬
            result = New ConvertUnitList
        End Try

        result.mFileName = fileName
        Return result
    End Function

    Public Sub Save()
        Try
            Dim serializer As XmlSerializer = New XmlSerializer(GetType(ConvertUnitList))
            Using stream As StreamWriter = New StreamWriter(Me.mFileName)
                serializer.Serialize(stream, Me)
                stream.Close()
            End Using
        Catch ex As Exception
            'ۑɎsۂ̏
            Throw ex
        End Try
    End Sub
#End Region

#Region "IXmlSerializable̎"
    Public Function GetSchema() As XmlSchema Implements IXmlSerializable.GetSchema
        Return Nothing
    End Function

    Public Sub ReadXml(ByVal reader As XmlReader) Implements IXmlSerializable.ReadXml
        Me.mItems = New List(Of ConvertUnit)
        reader.ReadStartElement()
        Do While reader.LocalName = "ConvertUnit"
            Dim cu As ConvertUnit = New ConvertUnit
            cu.ReadXml(reader)
            Me.mItems.Add(cu)
        Loop
        reader.ReadEndElement()
    End Sub

    Public Sub WriteXml(ByVal writer As XmlWriter) Implements IXmlSerializable.WriteXml
        For Each item As ConvertUnit In Me.mItems
            item.WriteXml(writer)
        Next
    End Sub
#End Region

End Class
