Public Class MainForm
    Private mConvertUnitList As ConvertUnitList

#Region "tH[Cxg"
    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.mConvertUnitList = ConvertUnitList.Load(Me.GetSettingFileName())
        If Me.mConvertUnitList.Items.Count = 0 Then
            MessageBox.Show("[go^Ă܂Bu[go^vʂ\܂̂ŁA[go^ĂB")
            My.Forms.RateEntryForm.OpenForm(Me.mConvertUnitList)
        End If
        CreateMenu()
    End Sub

    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Me.mConvertUnitList.Save()
    End Sub
#End Region

#Region "L[Cxg"
    Private Sub MainForm_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyCode
            Case Keys.Up, Keys.Down
                'ׂđI
                BaseTextBox.SelectionStart = 0
                BaseTextBox.SelectionLength = BaseTextBox.TextLength
                e.Handled = True
        End Select
    End Sub

    Private Sub MainForm_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress
        Select Case e.KeyChar
            Case Microsoft.VisualBasic.ChrW(Keys.Back)
                'Ȃ
            Case "0"c To "9"c, "#"c, "."c, "*"c
                SetTextBox(e.KeyChar.ToString())
                e.Handled = True
            Case Else
                '͂̂Ă
                e.Handled = True
        End Select
    End Sub
#End Region

#Region "j[Cxg"
    Private Sub SwapMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SwapMenuItem.Click
        SwapConvertUnit()
    End Sub

    Private Sub SelectedRateMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        ChangeConvertUnit(CType(sender, MenuItem))
    End Sub

    Private Sub EntryRateMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EntryRateMenuItem.Click
        If My.Forms.RateEntryForm.OpenForm(Me.mConvertUnitList) Then
            'j[Đ
            CreateMenu()
        End If
    End Sub

    Private Sub CloseMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseMenuItem.Click
        Me.Close()
    End Sub
#End Region

#Region "{^Cxg"
    Private Sub BaseTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BaseTextBox.TextChanged
        Calc()
        Call BaseTextBox.Focus()
    End Sub

    Private Sub NumButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles Num1Button.Click, Num2Button.Click, Num3Button.Click, Num4Button.Click, Num5Button.Click, _
                Num6Button.Click, Num7Button.Click, Num8Button.Click, Num9Button.Click, Num0Button.Click, _
                DotButton.Click
        Dim btn As Button = DirectCast(sender, Button)
        SetTextBox(btn.Text)
    End Sub

    Private Sub ClearButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearButton.Click
        ClearTextBox()
    End Sub
#End Region

#Region "vCx[g\bh"
    Private Function GetSettingFileName() As String
        Dim asm As System.Reflection.Assembly = System.Reflection.Assembly.GetExecutingAssembly()
        Dim exePath As String = asm.ManifestModule.FullyQualifiedName
        Dim fileName As String = System.IO.Path.ChangeExtension(exePath, "xml")
        Return fileName
    End Function

    Private Sub SetTextBox(ByVal text As String)
        Dim result As Boolean = False
        Select Case text
            Case "0"
                '0͂ĂΓ͂ȂB
                If BaseTextBox.Text = "0" Then
                    Return
                End If

            Case "*"
                '[es]Ή
                '#́uCLRvƂ
                ClearTextBox()
                Return

            Case ".", "#"
                '[es]Ή
                '#́u.vƂ
                text = "."

                '.ΉȂ
                If BaseTextBox.Text.IndexOf(".") >= 0 Then
                    Return
                End If

                '.̓͂Ȃ瓪0
                If BaseTextBox.Text = "" Then
                    text = "0."
                End If
        End Select

        With BaseTextBox
            .SelectedText = text
            .Focus()
        End With
    End Sub

    Private Sub ClearTextBox()
        With BaseTextBox
            .Text = ""
            .Focus()
        End With
    End Sub

    Private Sub Calc()
        '󕶎Ȃ猋ʂ󕶎ɂ
        If BaseTextBox.Text = "" Then
            ResultTextBox.Text = ""
            Exit Sub
        End If

        'l擾
        Dim value As Decimal
        Try
            value = CDec(BaseTextBox.Text)
        Catch e As InvalidCastException
            ResultTextBox.Text = "ϊs\"
            Return
        End Try

        'ConvertUnit擾
        Dim cu As ConvertUnit = Me.mConvertUnitList.SelectedUnit
        If cu Is Nothing Then
            ResultTextBox.Text = "`Ȃ"
            Return
        End If

        'vZ
        Try
            ResultTextBox.Text = cu.Convert(value).ToString()
        Catch ex As DivideByZeroException
            ResultTextBox.Text = "[Z"
        End Try
    End Sub

    Private Sub CreateMenu()
        Dim isChecked As Boolean = False

        'Uj[NA
        SelectRateMenuItem.MenuItems.Clear()

        For Each cu As ConvertUnit In Me.mConvertUnitList.Items
            'LȂΎ̃[v
            If Not cu.IsAvailable Then
                Continue For
            End If

            'j[𐶐
            Dim menu As MenuItem = New MenuItem
            menu.Text = cu.Description
            If cu.Selected Then
                menu.Checked = True
                InitConvertUnit(cu)
                isChecked = True
            End If
            AddHandler menu.Click, AddressOf SelectedRateMenuItem_Click
            SelectRateMenuItem.MenuItems.Add(menu)
        Next

        'ꌏ`FbNȂΐ擪`FbN
        If Not isChecked AndAlso SelectRateMenuItem.MenuItems.Count > 0 Then
            ChangeConvertUnit(SelectRateMenuItem.MenuItems(0))
        End If
    End Sub

    Private Sub ChangeConvertUnit(ByVal SelectedMenu As MenuItem)
        Dim cu As ConvertUnit = Me.mConvertUnitList.SetSelect(SelectedMenu.Text)

        '`FbNԂ̍XV
        Dim m As MenuItem
        For Each m In SelectRateMenuItem.MenuItems
            m.Checked = False
        Next
        SelectedMenu.Checked = True

        InitConvertUnit(cu)
    End Sub

    Private Sub SwapConvertUnit()
        Dim cu As ConvertUnit = Me.mConvertUnitList.SelectedUnit
        If cu Is Nothing Then Return

        't]
        cu.IsSwap = Not cu.IsSwap

        'lt]AtH[JX𖖔
        '(ʂȂ̂͌ŌvZ邩)
        BaseTextBox.Text = ResultTextBox.Text
        BaseTextBox.SelectionStart = BaseTextBox.Text.Length

        InitConvertUnit(cu)
    End Sub

    Private Sub InitConvertUnit(ByVal cu As ConvertUnit)
        BaseUnitNameLabel.Text = cu.SwapBaseUnitName
        ResultUnitNameLabel.Text = cu.SwapResultUnitName
        SwapMenuItem.Text = String.Format("ؑ({0}{1})", cu.SwapResultUnitName, cu.SwapBaseUnitName)
        Calc()
    End Sub
#End Region

End Class