Imports System.Text.RegularExpressions

Public Class RateEntryForm

#Region "ϐ`"
    Private mConvertUnitList As ConvertUnitList
#End Region

#Region "J\bh"
    Public Function OpenForm(ByVal cuList As ConvertUnitList) As Boolean
        Me.mConvertUnitList = cuList
        LoadList()
        If Me.ShowDialog() = Windows.Forms.DialogResult.OK Then
            SaveList()
            Return True
        Else
            Return False
        End If
    End Function
#End Region

#Region "j[Cxg"
    Private Sub OKMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OKMenuItem.Click
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub CancelMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelMenuItem.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub
#End Region

#Region "{^Cxg"
    Private Sub UpButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpButton.Click
        'IĂȂΉȂ
        If RateListView.SelectedIndices.Count <= 0 Then
            Return
        End If

        Dim i As Integer = RateListView.SelectedIndices(0)
        '擪Ȃ牽Ȃ
        If i = 0 Then Return

        Dim item As ListViewItem = RateListView.Items(i)
        RateListView.Items.RemoveAt(i)
        RateListView.Items.Insert(i - 1, item)
    End Sub

    Private Sub DownButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DownButton.Click
        'IĂȂΉȂ
        If RateListView.SelectedIndices.Count <= 0 Then
            Return
        End If

        Dim i As Integer = RateListView.SelectedIndices(0)
        'Ȃ牽Ȃ
        If i = RateListView.Items.Count - 1 Then Return

        Dim item As ListViewItem = RateListView.Items(i)
        RateListView.Items.RemoveAt(i)
        RateListView.Items.Insert(i + 1, item)
    End Sub

    Private Sub AddButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddButton.Click
        If InputCheck() Then
            Dim cu As ConvertUnit = MakeConvertUnit()
            RateListView.Items.Add(MakeListViewItem(cu))
        End If
    End Sub

    Private Sub ReplaceButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReplaceButton.Click
        'IĂȂΉȂ
        If RateListView.SelectedIndices.Count <= 0 Then
            Return
        End If

        If InputCheck() Then
            Dim i As Integer = RateListView.SelectedIndices(0)
            Dim cu As ConvertUnit = CType(RateListView.Items(i).Tag, ConvertUnit)
            cu = MakeConvertUnit(cu)
            RateListView.Items.RemoveAt(i)
            RateListView.Items.Insert(i, MakeListViewItem(cu))
        End If
    End Sub

    Private Sub DeleteButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteButton.Click
        'IĂȂΉȂ
        If RateListView.SelectedIndices.Count <= 0 Then
            Return
        End If

        'Xgr[폜
        RateListView.Items.RemoveAt(RateListView.SelectedIndices(0))
    End Sub
#End Region

#Region "Xgr[Cxg"
    Private Sub RateListView_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RateListView.SelectedIndexChanged
        'IĂȂΉȂ
        If RateListView.SelectedIndices.Count <= 0 Then
            Return
        End If

        'IĂꌏڂTagConvertUnit擾
        Dim i As Integer = RateListView.SelectedIndices(0)
        Dim cu As ConvertUnit = CType(RateListView.Items(i).Tag, ConvertUnit)

        'ConvertUnit̓eeLXg{bNX֕\
        BaseRateTextBox.Text = cu.BaseRate.ToString()
        BaseUnitNameTextBox.Text = cu.BaseUnitName
        ResultRateTextBox.Text = cu.ResultRate.ToString()
        ResultUnitNameTextBox.Text = cu.ResultUnitName
    End Sub
#End Region

#Region "vCx[g\bh"
    Private Sub LoadList()
        RateListView.Items.Clear()
        For Each cu As ConvertUnit In Me.mConvertUnitList.Items
            RateListView.Items.Add(MakeListViewItem(cu))
        Next

        BaseRateTextBox.Text = String.Empty
        BaseUnitNameTextBox.Text = String.Empty
        ResultRateTextBox.Text = String.Empty
        ResultUnitNameTextBox.Text = String.Empty
    End Sub

    Private Sub SaveList()
        Me.mConvertUnitList.Items.Clear()
        For Each item As ListViewItem In RateListView.Items
            Dim cu As ConvertUnit = CType(item.Tag, ConvertUnit)
            cu.IsAvailable = item.Checked
            Me.mConvertUnitList.Items.Add(cu)
        Next
    End Sub

    Private Function MakeListViewItem(ByVal cu As ConvertUnit) As ListViewItem
        Dim item As ListViewItem = New ListViewItem()
        item.Text = ""
        item.Checked = cu.IsAvailable
        item.SubItems.Add(cu.Description)
        item.Tag = cu
        Return item
    End Function

    Private Function MakeConvertUnit(Optional ByVal cu As ConvertUnit = Nothing) As ConvertUnit
        Dim result As ConvertUnit = New ConvertUnit
        result.BaseRate = CDec(BaseRateTextBox.Text)
        result.BaseUnitName = BaseUnitNameTextBox.Text
        result.ResultRate = CDec(ResultRateTextBox.Text)
        result.ResultUnitName = ResultUnitNameTextBox.Text
        If cu IsNot Nothing Then
            result.IsAvailable = cu.IsAvailable
            result.IsSwap = cu.IsSwap
            result.Selected = cu.Selected
        End If
        Return result
    End Function

    Private Function InputCheck() As Boolean
        Dim result As Boolean = True

        result = result AndAlso CheckRate(BaseRateTextBox.Text)
        result = result AndAlso CheckUnitName(BaseUnitNameTextBox.Text)
        result = result AndAlso CheckRate(ResultRateTextBox.Text)
        result = result AndAlso CheckUnitName(ResultUnitNameTextBox.Text)

        If Not result Then
            messagebox.Show("͒lɌ肪܂Bēx͂ĂB")
        End If

        Return result
    End Function

    Private Function CheckRate(ByVal value As String) As Boolean
        Return Regex.IsMatch(value, "^([1-9][0-9]*(\.[0-9]+)?|0\.[0-9]+)$")
    End Function

    Private Function CheckUnitName(ByVal value As String) As Boolean
        '̂Ƃ뉽łOK
        Return True
    End Function
#End Region

End Class